/*
 * isdrush - load YAT pictures (DOS)
 *   Copyright (C)1999 Tachibana Eriko
 */

#include <sys/dos.h>

#include "isd_header.h"


/* External functions */
extern void yat_sub (char* buf);


/* Function */
int
dos_yat (int fd, int frame_num, int* tbl_ptr, char* buf)
{
  int* tbl_end = tbl_ptr + frame_num;

  while (tbl_ptr < tbl_end)
    {
      int frame_size = *tbl_ptr++;

      if (_dos_read (fd, buf, frame_size) != frame_size)
	break;

#ifdef HAVE_YAT_BIN
      yat_sub (buf);
#endif

      if (_dos_k_keysns () && _dos_k_keyinp () == 0x1b)
	return _dos_k_sftsns () & 1;	/* ESC ĂI */
    }

  return 0;
}

#ifdef HAVE_YAT_BIN
__asm ("_yat_sub:\n\t"
	"movea.l (4,sp),a0\n\t"
	"movem.l d3-d7/a3-a6,-(sp)\n\t"
	"bsr yat_sub\n\t"
	"movem.l (sp)+,d3-d7/a3-a6\n\t"
	"rts\n\t"
       "yat_sub::\n\t"
	".insert yat.bin");
#endif

/* EOF */
